use std::io::prelude::*;
use std::net::TcpStream;
use rand;
use rand::Rng;
use image;
use image::GenericImageView;
use std::thread;

fn thrd(server: String, image: String, xoff: u32, yoff: u32, rotate: u32) {
    println!("server: {}", server);

    let mut stream = TcpStream::connect(&server).unwrap();

    stream.write("SIZE\n".as_bytes()).unwrap();

    let mut buf = [0; 128];

    let res = stream.read(&mut buf).unwrap();

    println!("{}", res);
    println!("{}", std::str::from_utf8(&buf).unwrap_or("error"));

    let mut x = 0;
    let mut y = 0;

    let mut rng = rand::thread_rng();


    let img = image::open(image).unwrap();
    println!("dimensions {:?}", img.dimensions());
    println!("pixel at 0 0 {:?}", img.get_pixel(0,0));

    println!("redness of pixel at 0 0 {:02x}", img.get_pixel(0,0).0[0]);

    //702, 960

    let width = img.dimensions().0 - 1;
    let height = img.dimensions().1 - 1;

    loop {
        x = (x + rng.gen_range(0..=10) + (width - 5)) % width;
        y = (y + rng.gen_range(0..=10) + (height - 5)) % height;

        let pixel = img.get_pixel(x,y).0;

        let xout = match rotate % 4 {
            0 => x,
            1 => y,
            2 => width-x,
            3 => height-y,
            _ => unreachable!(),
        };
        let yout = match rotate % 4 {
            0 => y,
            1 => width-x,
            2 => height-y,
            3 => x,
            _ => unreachable!(),
        };

        if pixel[3] > 0 || rng.gen_range(0..=300) == 0 {
            stream.write(format!("PX {} {} {:02x}{:02x}{:02x}\n", xout + xoff, yout + yoff, pixel[0], pixel[1], pixel[2]).as_bytes()).unwrap();
        }

        /*for x in 0..100 {
            for y in 0..100 {

            }
        }*/
        //print!(".");
    }

    //Ok(())
}


fn main() {
    let args: Vec<String> = std::env::args().collect();
    let image = args.get(1).unwrap_or(&"/home/robert/downloads/rustacean-flat-happy025.png".to_string()).to_owned();
    let x = args.get(2).unwrap_or(&"0".to_string()).parse::<u32>().unwrap();
    let y = args.get(3).unwrap_or(&"0".to_string()).parse::<u32>().unwrap();
    let rotate = args.get(4).unwrap_or(&"0".to_string()).parse::<u32>().unwrap();
    let server = args.get(5).unwrap_or(&"151.217.24.103:1337".to_string()).to_owned();


    for i in 1..40 {
        let imageclone = image.clone();
        let serverclone = server.clone();
        thread::spawn(move || {
            thrd(serverclone, imageclone, x, y, rotate);
        });
    }
    thrd(server, image, x, y, rotate);
}
